import java.util.regex.Pattern;

public class TestPattern {
    /** word characters and #@$,.+-[] plus space */
    private static final String PATH_CHARS = "[\\w #@$,.+\\-\\[\\]]";

    /** exact one path character without dot  */
    private static final String PATH_CHARS_NO_DOT = PATH_CHARS.replace(".", "");

    /** ".." or space */
    private static final String BAD_CHARS = "(\\.{2,})|( )";

    /** $(VARIABLE_NAME) */
    private static final String VARIABLE =
                    // 3 variable definition including braces
                    "(\\$\\(" +
                // 4: variable content: word character or _-
                        "([\\w_\\-]+)" +
            "\\))";

    /**
     * each segment must not have neither leading (?! ) nor trailing (?<! ) bad chars (
     * ".." or " ")
     */
    private static final String PATH_SEGMENT =
            "(?!" + BAD_CHARS + ")" +
            "(" +
                    "(" + PATH_CHARS_NO_DOT  + "{1,1})" +
                    "|" +
                    "(" + PATH_CHARS + "){2,}" +
             ")+" +
             "(?<!" + BAD_CHARS + ")";

    private static final String RELATIVE_PATH =
            "(" + PATH_SEGMENT + ")" + "(/" + PATH_SEGMENT + ")*";

    private static final String ABS_PATH = "/" + RELATIVE_PATH;

    /**
     * Two top level groups - absolute path (with variable or not) or relative.
     */
    public static final Pattern PATH_PATTERN = Pattern.compile(
            "(" +
                    // 4 variable
                    "(" + VARIABLE + ")?" +
                    // 5 absolute path
                    "(" + ABS_PATH + ")?" +
            ")" +
            "|" +
            // 18 relative path
            "(" + RELATIVE_PATH + ")"
     );
	
	public static void main(String[] args) {
		System.out.println(PATH_PATTERN.matcher("/workspaces/socbm557/complab/ws-Incorruptus-MX/NoPatch/mixedsignaldevices-master@8472b8bf32f(2)/Incorruptus_MX_Complab").matches());
	}
}
